## Reduce-svn4829-src.tar.gz

=== CMakeLists.txt ===
#############################################################################
# Name:        CMakeLists.txt
# Purpose:     Primary CMake for wxWidgets
# Author:      Tobias Taschner
# Created:     2016-09-20
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

cmake_minimum_required(VERSION 2.8.12)

if(APPLE AND NOT CMAKE_OSX_DEPLOYMENT_TARGET)
    # If no deployment target has been set default to the minimum supported
    # OS X version (this has to be set before the first project() call)
    set(CMAKE_OSX_DEPLOYMENT_TARGET 10.7 CACHE STRING "OS X Deployment Target")
endif()

project(wxWidgets)

include(build/cmake/policies.cmake NO_POLICY_SCOPE)

# Initialize variables for quick access to wx root dir in sub dirs
set(wxSOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(wxBINARY_DIR ${CMAKE_BINARY_DIR})
set(wxOUTPUT_DIR ${wxBINARY_DIR}/lib)

# parse the version number from wx/version.h and include in wxMAJOR_VERSION and wxMINOR_VERSION
file(READ include/wx/version.h WX_VERSION_H_CONTENTS)
string(REGEX MATCH "wxMAJOR_VERSION[ \t]+([0-9]+)"
    wxMAJOR_VERSION ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxMAJOR_VERSION ${wxMAJOR_VERSION})
string(REGEX MATCH "wxMINOR_VERSION[ \t]+([0-9]+)"
    wxMINOR_VERSION ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxMINOR_VERSION ${wxMINOR_VERSION})
string(REGEX MATCH "wxRELEASE_NUMBER[ \t]+([0-9]+)"
    wxRELEASE_NUMBER ${WX_VERSION_H_CONTENTS})
string (REGEX MATCH "([0-9]+)"
    wxRELEASE_NUMBER ${wxRELEASE_NUMBER})
# Determine if current version is a "Development" release
math(EXPR rel_dev "${wxMINOR_VERSION} % 2")
if(rel_dev)
    set(wxVERSION_IS_DEV TRUE)
else()
    set(wxVERSION_IS_DEV FALSE)
endif()

set(wxVERSION ${wxMAJOR_VERSION}.${wxMINOR_VERSION}.${wxRELEASE_NUMBER})
set(wxCOPYRIGHT "1992-2016 wxWidgets")

include(build/cmake/main.cmake)

# Set the default startup project for Visual Studio
if(wxBUILD_SAMPLES AND wxUSE_GUI)
    set_directory_properties(PROPERTIES VS_STARTUP_PROJECT minimal)
endif()

=== Makefile ===
# This is a hand-written top-level Makefile
# The main usage will be
#    make       make all configured CSL and PSL versions of Reduce
#    make csl   make just the CSL versions
#    make psl   make just the PSL versions
#    make <anything> sequential
#               normally if there are both CSL and PSL versions configured
#               or if there are several variants of one of those (eg debug
#               and regular) this makes them all in parallel. That can make
#               the rebuild much faster, but it leaves the output showing
#               parts of all the builds interleaved, so if something goes
#               wrong it is unhelpful. Use "sequential" to force sequential
#               rather than parallel building if you need to keep a log for
#               debugging or diagnosis.
#
#   make csl-sanity-check.sh
#               A simple test to ensure that there is at least a chance of
#               building the CSL version. This compiles a small test program
#               that should pop up a window.
#   [make snapshot] Work in progress to make a distributable archive relevant
#               to the current architecture.
#   [make install] Work in progress at this stage.


.PHONY: dist all csl psl csl-sanity-test snapshot install

# When debugging it may be useful to invoke scripts/make.sh in a noisy way...
# as in "make VERBOSE=-v"

# By default or with an explicit target "all" this will try to
# (re-)build all versions of Reduce that have been configured.

all:
	+$(SHELL) $(VERBOSE) scripts/make.sh $(MAKECMDGOALS)

# This script tries a fairly basic sanity check to see if the
# support-tools, include files and libraries needed to build the
# CSL version of Reduce are available. It is NOT a perfect test but
# may be useful in case of difficulty. See README.testprogram in the
# csl directory for further explanation and especially for how to
# run this test step by step manually. If the test succeeds it should
# pop up a Window with the word "Arthur" in it.

csl-sanity-test:
	if which cygcheck > /dev/null; then $(SHELL) $(VERBOSE) scripts/cygwin-sanity-check.sh ; fi
	$(SHELL) $(VERBOSE) scripts/csl-sanity-check.sh

# "make snapshot" will, when I have finished implementing support for it,
# create a file or several files in the directory "snapshots" representing
# a distributable archive for the current system. I intend to make this
# take over from the current situation where there are directories called
# debianbuild, macbuild and winbuild each with separate sets of arrangements.
# Well packing for different architectures will still involve platform-specific
# code but I will arrange that through scripts triggerable in a uniform manner
# here
snapshot:
# First build binaries for this machine.
	$(MAKE)
# Then package the resulting binaries as a .deb, .rpm, .dmg or as a windows
# installer file.
	scripts/snapshot.sh


# "make install" will try to install both CSL and PSL versions (if
# configured) in the same place and manner that they would have been
# installed using the platform-specific installers. This should work
# on Linux/Unix but the situation on Macintosh and Windows will be
# harder. On *ix it will honours the "--prefix" option used with configure,
# but on Windows it will probably always install in a default location.
# Well the "install" option is somewhjat work in progress.

install:
	$(SHELL) $(VERBOSE) scripts/install-reduce.sh $(MAKECMDGOALS)

uninstall:
	$(SHELL) $(VERBOSE) scripts/uninstall.sh $(MAKECMDGOALS)

.PHONY:	csl psl

csl psl:
	+$(SHELL) $(VERBOSE) scripts/make.sh $(MAKECMDGOALS)

%::
	+$(SHELL) $(VERBOSE) scripts/make.sh $(MAKECMDGOALS)

# end of Makefile

=== debianbuild/Makefile ===
# Makefile for debianbuild

SNAPSHOTDATE=$(shell LANG=C date "+%Y-%m-%d")
ifeq ($(REVISION),)
SNAPSHOT=$(SNAPSHOTDATE)
else
SNAPSHOT=$(REVISION)
endif
MACHINE=$(shell uname -m)
NOW=$(shell LANG=C date "+%a, %d %b %Y %T %z")
CHANGELOG=reduce/debian/changelog
BUILDTOPDIR=C
REVISION=HEAD
BUILD=$(shell $(BUILDTOPDIR)/scripts/findhost.sh $(shell $(BUILDTOPDIR)/config.guess))

all:	update-changelog reduce-packages

update-changelog:
	if head -1 $(CHANGELOG) | grep $(SNAPSHOT) >/dev/null ; then : ; \
	else  \
	  ( echo "reduce ("$(SNAPSHOT)") unstable; urgency=low" ; \
	    echo ; \
	    echo "  * New Snapshot. Date $(SNAPSHOTDATE)." ; \
	    echo ; \
	    echo " -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net> " $(NOW) ;\
	    echo ) > $(CHANGELOG).tmp ; \
	  cat $(CHANGELOG) >> $(CHANGELOG).tmp ; \
	  mv $(CHANGELOG).tmp $(CHANGELOG); \
	fi


$(BUILDTOPDIR).stamp:
	rm -rf $(BUILDTOPDIR)
	( time svn export -r $(REVISION) .. $(BUILDTOPDIR) ) > $(BUILDTOPDIR).log
	( cd $(BUILDTOPDIR) ; ./autogen.sh -f )
	-rm -rf reduce-source_$(SNAPSHOT)
	touch $(BUILDTOPDIR).stamp

reduce-packages:	$(BUILDTOPDIR).stamp debpackages rpmpackages tarpackages

debpackages:
	cd reduce ; \
	debuild --set-envvar BUILDTOPDIR=$(realpath $(BUILDTOPDIR)) \
	    --preserve-envvar=DH_OPTIONS -b -us -uc

rpmpackages:
	for f in reduce-*_$(SNAPSHOT)_*.deb ; \
	  do \
	     msg=`fakeroot alien -k -r -g $${f}` ; \
	     msg=$${msg#Directory } ; dir=$${msg% prepared*} ; \
	     arch=$${f##*_} ; arch=$${arch%.deb} ; rpmarch=`echo $${arch} | sed -e 's/all/noarch/' -e 's/amd64/x86_64/'` ; \
	     pkg=$${f%.deb} ; \
	     (cd $${dir} ; \
	      tar -c -z -f ../$${pkg}.tgz --exclude='*.spec' . ; \
	      sed -i -e '/^%dir "\(\/\|\/usr\/\|\/usr\/bin\/\|\/usr\/lib\/\|\/usr\/share\/\|\/usr\/share\/doc\/\|\/etc\/\)"/d' *.spec ; \
	      rpmbuild -bb --buildroot=`pwd` --target=$${rpmarch} *.spec >/tmp/$${dir}.log 2>&1 ; \
	      test -n "$?" && echo Build of $${dir} failed: $?, log file follows: && cat /tmp/$${dir}.log ; \
	      echo rm -f /tmp/$${dir}.log ; \
	     ) ; \
	  done

TARDEST=/tmp/reduce-snapshot_$(SNAPSHOT)_$(MACHINE)

tarpackages:
# This assumes that both the CSL and PSL versions have already been built in
# the $(BUILDTOPDIR) directory. (PSL not on ARM...)
	rm -rf $(TARDEST)
	mkdir $(TARDEST)
	mkdir $(TARDEST)/csl
ifeq (,$(findstring arm,$(MACHINE)))
	mkdir $(TARDEST)/psl
endif
	mkdir $(TARDEST)/reduce.doc
	cp $(BUILDTOPDIR)/doc/manual/manual.pdf $(TARDEST)/manual.pdf
	cp $(BUILDTOPDIR)/scripts/cslhere.sh $(TARDEST)/redcsl
ifeq (,$(findstring arm,$(MACHINE)))
	cp $(BUILDTOPDIR)/scripts/pslhere.sh $(TARDEST)/redpsl
endif
	cp -r $(BUILDTOPDIR)/xmpl $(TARDEST)
	cp $(BUILDTOPDIR)/cslbuild/$(BUILD)/csl/csl $(TARDEST)/csl
	cp $(BUILDTOPDIR)/cslbuild/$(BUILD)/csl/csl.img $(TARDEST)/csl
	cp $(BUILDTOPDIR)/cslbuild/$(BUILD)/csl/reduce $(TARDEST)/csl
	cp $(BUILDTOPDIR)/cslbuild/$(BUILD)/csl/reduce.img $(TARDEST)/csl
	cp -r $(BUILDTOPDIR)/cslbuild/$(BUILD)/csl/reduce.fonts $(TARDEST)/csl
	cp -r $(BUILDTOPDIR)/cslbuild/$(BUILD)/csl/reduce.resources $(TARDEST)/csl
	cp $(BUILDTOPDIR)/generic/newfront/build/rfcsl $(TARDEST)
	cp $(BUILDTOPDIR)/cslbuild/$(BUILD)/csl/reduce.doc/BINARY-LICENSE.txt $(TARDEST)/reduce.doc
	cp $(BUILDTOPDIR)/cslbuild/$(BUILD)/csl/reduce.doc/BSD-LICENSE.txt $(TARDEST)/reduce.doc
ifeq (,$(findstring arm,$(MACHINE)))
	cp -r $(BUILDTOPDIR)/pslbuild/$(BUILD)/psl $(TARDEST)/psl
	cp -r $(BUILDTOPDIR)/pslbuild/$(BUILD)/red $(TARDEST)/psl
	cp $(BUILDTOPDIR)/generic/newfront/build/rfpsl $(TARDEST)
endif
	chmod +x $(TARDEST)/redcsl $(TARDEST)/rfcsl
ifeq (,$(findstring arm,$(MACHINE)))
	chmod +x $(TARDEST)/redpsl $(TARDEST)/rfpsl 
endif
	tar cfj reduce-freestanding_$(SNAPSHOT)_$(MACHINE).tar.bz2 -C /tmp reduce-snapshot_$(SNAPSHOT)_$(MACHINE)

source-archive:
	-rm -rf reduce-source_$(SNAPSHOT) *.tar.bz2
	cp -r $(BUILDTOPDIR) reduce-source_$(SNAPSHOT)
	$(MAKE) reduce-source-core_$(SNAPSHOT).tar.bz2
	$(MAKE) reduce-source-csl_$(SNAPSHOT).tar.bz2
	$(MAKE) reduce-source-csl-embedded_$(SNAPSHOT).tar.bz2
	$(MAKE) reduce-source-csl-support_$(SNAPSHOT).tar.bz2
ifeq (,$(findstring arm,$(MACHINE)))
	$(MAKE) reduce-source-psl_$(SNAPSHOT).tar.bz2
endif
	ls -lh *.tar.bz2
#	-rm -rf reduce-source_$(SNAPSHOT)

reduce-source-core_$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-core_$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		--exclude=reduce-source_$(SNAPSHOT)/csl \
		--exclude=reduce-source_$(SNAPSHOT)/psl \
		reduce-source_$(SNAPSHOT)

reduce-source-csl_$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-csl_$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		--exclude=reduce-source_$(SNAPSHOT)/csl/support-packages \
		--exclude=reduce-source_$(SNAPSHOT)/csl/embedded \
		--exclude=reduce-source_$(SNAPSHOT)/csl/new-embedded \
		--exclude=reduce-source_$(SNAPSHOT)/csl/generated-c \
		reduce-source_$(SNAPSHOT)/csl

reduce-source-csl-embedded_$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-csl-embedded_$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		reduce-source_$(SNAPSHOT)/csl/embedded \
		reduce-source_$(SNAPSHOT)/csl/new-embedded \
		reduce-source_$(SNAPSHOT)/csl/generated-c

reduce-source-csl-support_$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-csl-support_$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		reduce-source_$(SNAPSHOT)/csl/support-packages

ifeq (,$(findstring arm,$(MACHINE)))
# PSL is not at present available on the ARM.
reduce-source-psl_$(SNAPSHOT).tar.bz2:
	tar cfj reduce-source-psl_$(SNAPSHOT).tar.bz2 \
		--owner=root --group=root \
		reduce-source_$(SNAPSHOT)/psl
endif

clean:
	rm -rf $(BUILDTOPDIR) $(BUILDTOPDIR).log
	rm -f *.deb *.rpm *.tgz *.tar.bz2 *.stamp

# end of Makefile

=== vsl/Makefile ===
# Makefile for vsl

CC = gcc
OPT = -O3

all:	vsl vsl.img vslmanual.pdf

# The "PSL" target makes vsl but with a reader that treats most punctuation
# characters as if they were letters so that symbols can have names such as
# *x*, &a, abc-def, 1+ and {q} without needing escape characters.

# I am making vsl use "libedit" for input local editing, which gives it
# input history etc. 

psl:	vslpsl vsl.img

.PHONY:	vslpsl

vsl:	vsl.c
	$(CC) $(OPT) -Wall vsl.c -lm -ledit -o vsl

vslpsl:	vsl.c
	$(CC) -DPSL=1 $(OPT) -Wall vsl.c -lm -ledit -o vsl

vsl.img:	vsl library.lsp vsl.lsp extras.lsp
	./vsl -z library.lsp

clean:
	rm -f *.o *.bak *.exe *.log *.img vsl *.ind *.aux *.idx *.ilg *~

# To build this you need to go "make vslmanual.pdf" explicitly. It is
# not done automatically because not everybody will have installed
# pdflatex.

vslmanual.pdf:	vslmanual.tex vslfunctions.tex
	touch vslmanual.ind
	pdflatex vslmanual.tex
	makeindex vslmanual.idx
	pdflatex vslmanual.tex
	pdflatex vslmanual.tex

# end of Makefile

=== winbuild/Makefile ===
# Makefile for getting ready to make Windows installer package

ifeq ($(REVISION),)
SNAPSHOT=$(shell LANG=C date "+%Y-%m-%d")
else
SNAPSHOT=$(REVISION)
endif
BUILDTOPDIR=C
REVISION=HEAD

# If the following path to Inno Setup is correct then running "make" will
# be able to run Inno Setup automatically. If it is not then there will
# be no terrible harm, but when you run "make" it will end by displaying
# a message asking you to run Inno Setup manually.

inno=/cygdrive/c/Program Files (x86)/Inno Setup 5

all:	package-win

# The sub-parts of this build process are controlled by a collection
# of datestamp files *.stamp. "make clean" will remove all of these and so
# force you to remake everything from scratch. Otherwise once one of these
# has been created it just sits there and prevents re-building of its
# component

# "$(BUILDTOPDIR)" is a copy of the main Reduce source tree. It will include
# everything that is checked in to the subversion repository but it will
# not include locally created files. If you have updated a file locally
# (even if you have not yet committed your changes) then that update will
# find its way into the clean tree. The purpose of all this is so that the
# setup process can dump large sections of the Reduce tree into the
# installation set without needing to enumerate files individually. A previous
# version of the script used the local copy of the main tree and could end
# up getting ready to distribute large amounts of temporary or experimental
# material.

$(BUILDTOPDIR).stamp:
	rm -rf $(BUILDTOPDIR)
	( time svn export -r $(REVISION) .. $(BUILDTOPDIR); \
	  cd $(BUILDTOPDIR); ./autogen.sh ) > $(BUILDTOPDIR).log
	touch $(BUILDTOPDIR).stamp

# The CSL version of Reduce gets build using an elaborate scheme that
# creates a sort of Windows "fat binary" such that a single binary can be
# used on 32 or 64-bit systems and to run as a Windowed version or under
# a Windows console - or under cygwin mintty or using an X server!

csl.stamp:	$(BUILDTOPDIR).stamp
	script -c "time ./cslbuild.sh" csl.log
	touch csl.stamp

# The PSL version gets built for both 32 and 64-bit architectures. Because
# it is built in the clean tree it will be a fully fresh pair of versions
# fully re-build here.

psl.stamp:	$(BUILDTOPDIR).stamp
	(cd $(BUILDTOPDIR) ; \
		./configure --with-psl ; \
		./configure --with-psl --with-m32 ; \
		script -c "time make psl" ../psl.log )
	touch psl.stamp

# Documentation is also re-generated in the clean tree so that regardless
# of history it should end up fresh and tidy.

docs.stamp:	$(BUILDTOPDIR).stamp
	(cd $(BUILDTOPDIR)/doc/misc ; script -c "time make"  ../../../docmisc.log )
	(cd $(BUILDTOPDIR)/doc/manual ; script -c "time make" ../../../docmanual.log )
	touch docs.stamp

# reduce.iss is the script for Inno Setup. It is created here by
# setting the string @here@ in it to the absolute path to this
# directory. That is so that when Inno Setup processes it there is no
# reliance on any "current directory".

reduce.iss:	reduce.iss.in
	sed -e 's#\@here\@#$(subst /,\\,$(shell cygpath -m $(abspath .)))#; s#\@VERSION\@#$(shell date +%Y-%m-%d)#' \
		<reduce.iss.in >reduce.iss

# The final step in the creation of an installer involved saving PSL
# images for both 32 and 64-bit versions and then invoking Inno Setup
# to pack up everything.

package-win:	$(BUILDTOPDIR).stamp csl.stamp psl.stamp docs.stamp reduce.iss
	$(BUILDTOPDIR)/psl/saveimage.sh $(BUILDTOPDIR)/pslbuild/x86_64-pc-windows \
		$(abspath .) '$$reduce/lib/psl' && mv reduce.img reduce64.img
	$(BUILDTOPDIR)/psl/saveimage.sh $(BUILDTOPDIR)/pslbuild/i686-pc-windows \
		$(abspath .) '$$reduce/lib/psl'
	if test -x "$(inno)/ISCC.exe"; then "$(inno)/ISCC" reduce.iss;\
		else echo Please run Innosetup on winbuild/reduce.iss; fi
	mv Output/Reduce-Setup.exe Output/Reduce-Setup_$(SNAPSHOT).exe
# At present I do not know if the .cab files created here will be any
# use, but I will at least create SOMETHING so that they can be tested and
# negotiation as to just what is needed can begin.
	cd cslbuild && gcab -c -z ../Output/wincsl_$(SNAPSHOT).cab \
		reduce.exe reduce.fonts reduce.img reduce.resources winreduce.exe
	d=`pwd` && cd $(BUILDTOPDIR)/pslbuild/i686* && \
		gcab -c -z $$d/Output/winpsl32_$(SNAPSHOT).cab psl red
	d=`pwd` && cd $(BUILDTOPDIR)/pslbuild/x86_64* && \
		gcab -c -z $$d/Output/winpsl64_$(SNAPSHOT).cab psl red


# It will be a really good idea to go "make clean" before any wholesale
# "make" here - this removes all the working files that get created
# during the build. It will leave any final installer that is in the
# directory "Output"

clean:
	rm -rf cyg*.exe add*.exe *red*.exe *.img $(BUILDTOPDIR) \
		cslwin32 cslwin64 cslcyg32 cslcyg64 \
		cslbuild log reduce.iss dll*.c *.stamp

# end of Makefile

=== csl/cslbase/Makefile ===
# Do local maintenance in the cslbase directory

csl.pdf:	csl.tex
	rm -f csl.ind
	pdflatex csl
	makeindex csl
	pdflatex csl

lispfile:
	./lispfile.sh


.PHONY:	charmetrics.h
charmetrics.h:	charmetrics.cpp
	g++ -DCREATE charmetrics.cpp -o charmetrics && \
	./charmetrics && \
	g++ -DTEST charmetrics.cpp -o charmetrictest && \
	./charmetrictest

.PHONY: coverage.cpp
coverage.cpp:
	g++ glyphtable.cpp -o glyphtable
	./glyphtable wxfonts/*.glyphs

doxtract:	doxtract.cpp
	g++ doxtract.cpp -o doxtract

.PHONY:	csl.tex
csl.tex:	doxtract *.red *.lsp
	./doxtract -p csl -o csl.tex *.h *.cpp *.red *.lsp

# The following conversion does not map from C to C++ in any real way. It
# merely updates comments from "/* ... */" style to "//" style and re-indents
# code in a consistent way that is at least close to the one I have used
# when I hand-indent things.

c2cpp:	c2cpp.cpp
	g++ -O2 c2cpp.c -o c2cpp

# This is something I will want to be very cautious about and NOT do
#  automatically because if I where to reset a timestamp on any legacy
# C code this would clobber the C++ version even if I had made further
# adjustments to it. But the recipe here is to remind me how I did the
# initial conversion.

#%.cpp:	%.c c2cpp
#	./c2cpp $< $@
#	astyle $@

# end of Makefile in cslbase

=== csl/embedded/Makefile ===
# Makefile for this SIMPLE setup for Reduce building

CC=gcc
CFLAGS=-m32 -O2 -DHAVE_CONFIG_H=1 -DEMBEDDED=1 -pg

all:	reduce

reduce:		arith01.o arith02.o arith03.o arith04.o arith05.o \
		arith06.o arith07.o arith08.o arith09.o arith10.o \
		arith11.o arith12.o bytes.o char.o \
		csl.o cslmpi.o cslread.o eval1.o eval2.o eval3.o \
		eval4.o fasl.o fns1.o fns2.o fns3.o fwin.o gc.o \
		preserve.o print.o restart.o sysfwin.o termed.o \
		u01.o u02.o u03.o u04.o u05.o u06.o u07.o u08.o u09.o u10.o \
		u11.o u12.o u13.o u14.o u15.o u16.o u17.o u18.o u19.o u20.o \
		u21.o u22.o u23.o u24.o u25.o u26.o u27.o u28.o u29.o u30.o \
		u31.o u32.o u33.o u34.o u35.o u36.o u37.o u38.o u39.o u40.o \
		u41.o u42.o u43.o u44.o u45.o u46.o u47.o u48.o u49.o u50.o \
		u51.o u52.o u53.o u54.o u55.o u56.o u57.o u58.o u59.o u60.o
	$(CC) $(CFLAGS) arith01.o arith02.o arith03.o arith04.o arith05.o \
	arith06.o arith07.o arith08.o arith09.o arith10.o \
	arith11.o arith12.o bytes.o char.o \
	csl.o cslmpi.o cslread.o eval1.o eval2.o eval3.o \
	eval4.o fasl.o fns1.o fns2.o fns3.o fwin.o gc.o \
	preserve.o print.o restart.o sysfwin.o termed.o \
	u01.o u02.o u03.o u04.o u05.o u06.o u07.o u08.o u09.o u10.o \
	u11.o u12.o u13.o u14.o u15.o u16.o u17.o u18.o u19.o u20.o \
	u21.o u22.o u23.o u24.o u25.o u26.o u27.o u28.o u29.o u30.o \
	u31.o u32.o u33.o u34.o u35.o u36.o u37.o u38.o u39.o u40.o \
	u41.o u42.o u43.o u44.o u45.o u46.o u47.o u48.o u49.o u50.o \
	u51.o u52.o u53.o u54.o u55.o u56.o u57.o u58.o u59.o u60.o \
	-pg -lm -o reduce

# Create the reduce.img file

reduce.img:	reduce
	-mv reduce.img reduce.img.old
	-rm -f reduce.img
	./reduce -w -z -Dno_init_file ../cslbase/buildreduce.lsp \
		-D@srcdir=../cslbase \
		-o reduce.img \
		-l image.log

clean:
	rm -f *.o reduce

HEADERS = arith.h bytes.h clsyms.h config.h cslerror.h cslread.h \
	entries.h externs.h fwin.h headers.h machine.h proc.h \
	sockhdr.h stream.h syscsl.h tags.h termed.h version.h


arith01.o:	arith01.c $(HEADERS)
arith02.o:	arith02.c $(HEADERS)
arith03.o:	arith03.c $(HEADERS)
arith04.o:	arith04.c $(HEADERS)
arith05.o:	arith05.c $(HEADERS)
arith06.o:	arith06.c $(HEADERS)
arith07.o:	arith07.c $(HEADERS)
arith08.o:	arith08.c $(HEADERS)
arith09.o:	arith09.c $(HEADERS)
arith10.o:	arith10.c $(HEADERS)
arith11.o:	arith11.c $(HEADERS)
arith12.o:	arith12.c $(HEADERS)
bytes.o:	bytes.c $(HEADERS)
bytes1.o:	bytes1.c opnames.c $(HEADERS)
char.o:	char.c $(HEADERS)
csl.o:	csl.c $(HEADERS)
cslmpi.o:	cslmpi.c mpipack.c $(HEADERS)
cslread.o:	cslread.c $(HEADERS)
driver.o:	driver.c $(HEADERS)
embedcsl.o:	embedcsl.c csl.c $(HEADERS)
eval1.o:	eval1.c $(HEADERS)
eval2.o:	eval2.c $(HEADERS)
eval3.o:	eval3.c $(HEADERS)
eval4.o:	eval4.c $(HEADERS)
fasl.o:	fasl.c $(HEADERS)
fns1.o:	fns1.c $(HEADERS)
fns2.o:	fns2.c $(HEADERS)
fns3.o:	fns3.c $(HEADERS)
fwin.o:	fwin.c $(HEADERS)
gc.o:	gc.c $(HEADERS)
preserve.o:	preserve.c $(HEADERS)
print.o:	print.c $(HEADERS)
restart.o:	restart.c machineid.c $(HEADERS)
sysfwin.o:	sysfwin.c $(HEADERS)
termed.o:	termed.c $(HEADERS)
u01.o:	u01.c $(HEADERS)
u02.o:	u02.c $(HEADERS)
u03.o:	u03.c $(HEADERS)
u04.o:	u04.c $(HEADERS)
u05.o:	u05.c $(HEADERS)
u06.o:	u06.c $(HEADERS)
u07.o:	u07.c $(HEADERS)
u08.o:	u08.c $(HEADERS)
u09.o:	u09.c $(HEADERS)
u10.o:	u10.c $(HEADERS)
u11.o:	u11.c $(HEADERS)
u12.o:	u12.c $(HEADERS)
u13.o:	u13.c $(HEADERS)
u14.o:	u14.c $(HEADERS)
u15.o:	u15.c $(HEADERS)
u16.o:	u16.c $(HEADERS)
u17.o:	u17.c $(HEADERS)
u18.o:	u18.c $(HEADERS)
u19.o:	u19.c $(HEADERS)
u20.o:	u20.c $(HEADERS)
u21.o:	u21.c $(HEADERS)
u22.o:	u22.c $(HEADERS)
u23.o:	u23.c $(HEADERS)
u24.o:	u24.c $(HEADERS)
u25.o:	u25.c $(HEADERS)
u26.o:	u26.c $(HEADERS)
u27.o:	u27.c $(HEADERS)
u28.o:	u28.c $(HEADERS)
u29.o:	u29.c $(HEADERS)
u30.o:	u30.c $(HEADERS)
u31.o:	u31.c $(HEADERS)
u32.o:	u32.c $(HEADERS)
u33.o:	u33.c $(HEADERS)
u34.o:	u34.c $(HEADERS)
u35.o:	u35.c $(HEADERS)
u36.o:	u36.c $(HEADERS)
u37.o:	u37.c $(HEADERS)
u38.o:	u38.c $(HEADERS)
u39.o:	u39.c $(HEADERS)
u40.o:	u40.c $(HEADERS)
u41.o:	u41.c $(HEADERS)
u42.o:	u42.c $(HEADERS)
u43.o:	u43.c $(HEADERS)
u44.o:	u44.c $(HEADERS)
u45.o:	u45.c $(HEADERS)
u46.o:	u46.c $(HEADERS)
u47.o:	u47.c $(HEADERS)
u48.o:	u48.c $(HEADERS)
u49.o:	u49.c $(HEADERS)
u50.o:	u50.c $(HEADERS)
u51.o:	u51.c $(HEADERS)
u52.o:	u52.c $(HEADERS)
u53.o:	u53.c $(HEADERS)
u54.o:	u54.c $(HEADERS)
u55.o:	u55.c $(HEADERS)
u56.o:	u56.c $(HEADERS)
u57.o:	u57.c $(HEADERS)
u58.o:	u58.c $(HEADERS)
u59.o:	u59.c $(HEADERS)
u60.o:	u60.c $(HEADERS)


# end of Makefile

=== csl/new-embedded/Makefile ===
# Makefile for embedded and other custom versions of Reduce

# The Makefile here expect to use GNU make, but all the scripts
# obeyed are in fact VERY simple and so anybody who wants to build some
# alternative way ought not to have much trouble.

# This only works using gcc/g++

# The idea here is that there may be many different embedded variants.
# All of them will require a Reduce image file (typically called "reduce.img")
# but I show here how to build two variants. The first if a full image
# including pretty-well ALL of the capabilites of Reduce. The second
# (minireduce) is cut down, and while not quite minimal is at least a
# lot smaller. Anybody trying minireduce will want to review the file
# "packages.map" where it is built to ensure that they include just what
# THEY want. The version I provide here is merely a starting position.

# You should go either "make reduce" or "make minireduce" first to create
# the version of "reduce.img" that interests you.

# Here I always use gcc. If by default it gives me a 32-bit world
# then I use it simply. In not I will give it the flag "-m32" which may
# not always be supported but is by best bet. Those who wish to use other
# compilers etc need to make their own adjustments!

SIZE:=$(shell g++ checksize.cpp -o checksize && ./checksize 2>&1)
ifeq ($(findstring [[4]],$(SIZE)), [[4]])
CFLAGS=
else
CFLAGS=-m32
endif

.PHONY:	reduce
reduce: lib/libcrlibm.a lib/libsoftfloat.a
	cd reduce-image && \
		$(MAKE) CFLAGS=$(CFLAGS) reduce.img && \
		cp reduce.img ..

lib/libcrlibm.a:
	mkdir -p crlibm
	cd crlibm && CFLAGS=$(CFLAGS) \
		`pwd`/../../../libraries/crlibm/configure --prefix=`pwd`/..
	cd crlibm && $(MAKE) install

lib/libsoftfloat.a:
	mkdir -p softfloat
	cd softfloat && CFLAGS=$(CFLAGS) \
		`pwd`/../../../libraries/SoftFloat-3a/source/configure --prefix=`pwd`/..
	cd softfloat && $(MAKE) install

.PHONY:	minireduce
minireduce:	lib/libcrlibm.a lib/libsoftfloat.a
	cd minireduce-image && \
		$(MAKE) CFLAGS=$(CFLAGS) reduce.img && \
		cp reduce.img ..

# So far I provide only one sample. I call it "proc" and it illustrates
# a procedural interface into Reduce.

.PHONY:	proc
proc:	lib/libcrlibm.a lib/libsoftfloat.a reduce.img
	cd procedural && $(MAKE) CFLAGS=$(CFLAGS)

# If you go "make proc" without having gone either "make reduce" or
# "make minireduce" first it will default to the full build

reduce.img:	reduce

# Obviously one needs to tidy up occasionally.

clean:
	-rm -f reduce.img lib/* include/crlibm_config.h include/crlibm.h \
		include/scs.h include/softfloat.h include/softfloat_types.h
	if test -d crlibm; then cd crlibm && $(MAKE) clean; fi
	if test -d softfloat; then cd softfloat && $(MAKE) clean; fi
	cd reduce-image && $(MAKE) clean
	cd minireduce-image && $(MAKE) clean
	cd procedural && $(MAKE) clean

# end of Makefile

=== psl/dist/Makefile ===
###############################################################################
#
# File:         PSL:Makefile
# Description:  Top level makefile for PSL.
# Author:       Harold Carr and Leigh Stoller.
# Created:      04-Feb-87
#
# (c) Copyright 1987, University of Utah, all rights reserved.
###############################################################################
# Revisions:
# 
###############################################################################

# The next line is the only thing that needs to be changed between
# machines/directories.

## PROOT   = /home/cons/reducedev/free_reduce/reduce-algebra/trunk/psl

PSL	= $(PROOT)/dist
PSYS	= $(PROOT)/bin
PK	= $(PSL)/kernel
PXK     = $(PK)/$(MACHINE)
PNK	= $(PSL)/nonkernel
PXNK    = $(PNK)/$(MACHINE)
PNKL    = $(PXNK)/lap
PC	= $(PSL)/comp
PXC     = $(PC)/$(MACHINE)
PU	= $(PSL)/util
PXU     = $(PU)/$(MACHINE)
PDIST   = $(PSL)/distrib
PXDIST  = $(PDIST)/$(MACHINE)
PL      = $(PSL)/lap/$(MACHINE)

PROGRAMS = bare-psl psl pslcomp 

all: bfiles pnkl utilities compiler bpsl make-bare-psl make-psl make-pslcomp
	echo "PSL binaries rebuilt"

executables: make-bare-psl make-psl make-pslcomp

resize:
	rm -f $(PXK)/bps.o $(PXK)/bpsheap.o
	make $(MFLAGS) MACHINE=$(MACHINE) bpsl
	make $(MFLAGS) MACHINE=$(MACHINE) executables

oload:

bfiles: 
	(cd $(PXK); make $(MFLAGS) MACHINE=$(MACHINE) PSL=$(PSL) bfiles)

pnkl:
	(cd $(PXNK); make $(MFLAGS) MACHINE=$(MACHINE) PSL=$(PSL))
	(cd $(PNK) ; make $(MFLAGS) MACHINE=$(MACHINE) PSL=$(PSL))

compiler:
	(cd $(PXC) ; make $(MFLAGS) MACHINE=$(MACHINE) PSL=$(PSL))
	(cd $(PC)  ; make $(MFLAGS) MACHINE=$(MACHINE) PSL=$(PSL))

utilities:
	(cd $(PXU) ; make $(MFLAGS) MACHINE=$(MACHINE) PSL=$(PSL))
	(cd $(PU)  ; make $(MFLAGS) MACHINE=$(MACHINE) PSL=$(PSL))

bpsl: 
	(cd $(PXK) ; make $(MFLAGS) MACHINE=$(MACHINE) PSL=$(PSL) bpsl)

bare-psl: bpsl pnkl make-bare-psl

make-bare-psl:	sparsify
	(cd $(PDIST) ; gcc -Dhpux -o $(PSYS)/$(MACHINE)/sparsify sparsify.c; \
         csh -f make-bare-psl)

sparsify:	$(PSYS)/sparsify.c
	(cd $(PDIST) ; gcc -Dhpux -o $(PSYS)/$(MACHINE)/sparsify sparsify.c)

psl:	bpsl bare-psl utilities make-psl sparsify

make-psl:
	(cd $(PDIST) ; csh -f make-psl)

pslcomp:	bare-psl compiler utilities make-pslcomp sparsify 

make-pslcomp:
	(cd $(PDIST) ; csh -f make-pslcomp)

rlisp: bare-psl compiler utilities make-rlisp

make-rlisp:
	(cd $(PDIST) ; csh -f make-rlisp)


DESTDIR = /usr/site/bin

install:
	-cd $(PSYS)    ; rm -f oload
	-cd $(DESTDIR) ; rm -f $(PROGRAMS)
	-ln -s $(PSYS)/bare-psl $(DESTDIR)
	-ln -s $(PSYS)/psl      $(DESTDIR)
	-ln -s $(PSYS)/pslcomp  $(DESTDIR)
	-ln -s $(PSYS)/rlisp    $(DESTDIR)
	-ln -s $(PSL)/oload     $(PSYS)
	-ln -s $(PSYS)/oload    $(DESTDIR)

tape:
	csh -f $(PDIST)/cleanup.csh
	csh -f $(PDIST)/write-tape.csh

cleanup:
	csh -f $(PDIST)/cleanup.csh
	-rm -f $(PSYS)/old-*

# In order to rebuild the system, pslcomp and bpsl must exist.
clean:
	-rm -f $(PL)/*.b
	-rm -f $(PNKL)/*.b
	-rm -f $(PXK)/*.o
	-rm -f $(PXK)/dmain.s
	-rm -f $(PXK)/main.init
	-rm -f $(PXK)/main.s
	-rm -f $(PXK)/$(MACHINE).sym

# End of file.

=== build/cmake/demos/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/demos/CMakeLists.txt
# Purpose:     CMake script for demos
# Author:      Tobias Taschner
# Created:     2016-10-21
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

function(wx_add_demo name)
    cmake_parse_arguments(DEMO "" "NAME" "DATA;LIBRARIES" ${ARGN})
    if(NOT DEMO_NAME)
        set(DEMO_NAME ${name})
    endif()
    wx_list_add_prefix(src_files
        "${wxSOURCE_DIR}/demos/${name}/"
        ${DEMO_UNPARSED_ARGUMENTS})
    if(WIN32)
        list(APPEND src_files ${wxSOURCE_DIR}/demos/${name}/${DEMO_NAME}.rc)
    endif()
    add_executable(${DEMO_NAME} WIN32 MACOSX_BUNDLE ${src_files})
    if(DEMO_DATA)
        # TODO: unify with data handling for samples
        # TODO: handle data files differently for OS X bundles
        # Copy data files to output directory
        foreach(data_file ${DEMO_DATA})
            list(APPEND cmds COMMAND ${CMAKE_COMMAND}
                -E copy ${wxSOURCE_DIR}/demos/${name}/${data_file}
                ${wxOUTPUT_DIR}/${data_file})
        endforeach()
        add_custom_command(
            TARGET ${DEMO_NAME} ${cmds}
            COMMENT "Copying demo data files...")
    endif()
    if(wxBUILD_SHARED)
        target_compile_definitions(${DEMO_NAME} PRIVATE WXUSINGDLL)
    endif()
    target_link_libraries(${DEMO_NAME} core ${DEMO_LIBRARIES})
    wx_set_common_target_properties(${DEMO_NAME})
    set_target_properties(${DEMO_NAME} PROPERTIES FOLDER "Demos")
endfunction()

wx_add_demo(bombs
    bombs.cpp
    bombs1.cpp
    game.cpp
    )
wx_add_demo(forty
    forty.cpp
    canvas.cpp
    card.cpp
    game.cpp
    pile.cpp
    playerdg.cpp
    scoredg.cpp
    scorefil.cpp
    DATA
        about.htm
    LIBRARIES
        html adv xml
    )
wx_add_demo(fractal fractal.cpp)
wx_add_demo(life
    life.cpp
    dialogs.cpp
    game.cpp
    reader.cpp
    DATA
        breeder.lif
    )
wx_add_demo(poem wxpoem.cpp
    DATA
        wxpoem.txt wxpoem.dat wxpoem.idx
    LIBRARIES
        html
    NAME
        wxpoem
    )

=== build/cmake/lib/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/lib/CMakeLists.txt
# Purpose:     Main lib CMake file
# Author:      Tobias Taschner
# Created:     2016-10-14
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

include(../source_groups.cmake)

set(wxLIB_TARGETS)
if(wxBUILD_MONOLITHIC)
    # Initialize variables for monolithic build
    set(wxMONO_SRC_FILES)
    set(wxMONO_LIBS_PRIVATE)
    set(wxMONO_LIBS_PUBLIC)
    set(wxMONO_INCLUDE_DIRS_PRIVATE)
    set(wxMONO_INCLUDE_DIRS_PUBLIC)
endif()

# Define third party libraries
set(LIBS_THIRDPARTY regex zlib)
if(wxUSE_GUI)
    list(APPEND LIBS_THIRDPARTY jpeg png tiff)
endif()
foreach(LIB IN LISTS LIBS_THIRDPARTY)
    include(${LIB}.cmake)
endforeach()

# add_opt_lib()
# Add library which may have been disabled by wxUSE_...
macro(add_opt_lib name var_name)
    if(${var_name})
        list(APPEND LIBS ${name})
    endif()
endmacro()

# Define base libraries
set(LIBS base)
add_opt_lib(net wxUSE_SOCKETS)
add_opt_lib(xml wxUSE_XML)

# Define UI libraries
if(wxUSE_GUI)
    list(APPEND LIBS core adv)
    foreach(lib
        aui
        html
        propgrid
        ribbon
        richtext
        webview
        stc
        xrc
        )
        string(TOUPPER ${lib} _name_upper)
        add_opt_lib(${lib} wxUSE_${_name_upper})
    endforeach()
    add_opt_lib(media wxUSE_MEDIACTRL)
    add_opt_lib(gl wxUSE_OPENGL)
    add_opt_lib(qa wxUSE_DEBUGREPORT)
endif() # wxUSE_GUI

# Include cmake file for every library
foreach(LIB ${LIBS})
    add_subdirectory(${LIB})
endforeach()

if(wxBUILD_MONOLITHIC)
    # Create monolithic library target
    list(LENGTH wxMONO_SRC_FILES src_file_count)
    wx_add_library(mono ${wxMONO_SRC_FILES})
    foreach(vis PRIVATE PUBLIC)
        if(wxMONO_LIBS_${vis})
            # Remove libs included in mono from list
            foreach(lib IN LISTS LIBS)
                list(REMOVE_ITEM wxMONO_LIBS_${vis} ${lib})
            endforeach()

            target_link_libraries(mono ${vis} ${wxMONO_LIBS_${vis}})
        endif()
        if(wxMONO_INCLUDE_DIRS_${vis})
            target_include_directories(mono ${vis} ${wxMONO_INCLUDE_DIRS_${vis}})
        endif()
        if(wxMONO_DEFINITIONS_${vis})
            target_compile_definitions(mono ${vis} ${wxMONO_DEFINITIONS_${vis}})
        endif()
    endforeach()
endif()

# Propagate variable(s) to parent scope
set(wxLIB_TARGETS ${wxLIB_TARGETS} PARENT_SCOPE)
set(wxTHIRD_PARTY_LIBRARIES ${wxTHIRD_PARTY_LIBRARIES} PARENT_SCOPE)

=== build/cmake/samples/CMakeLists.txt ===
#############################################################################
# Name:        build/cmake/samples/CMakeLists.txt
# Purpose:     CMake script to build samples
# Author:      Tobias Taschner
# Created:     2016-10-04
# Copyright:   (c) 2016 wxWidgets development team
# Licence:     wxWindows licence
#############################################################################

wx_add_sample(access accesstest.cpp)
wx_add_sample(animate anitest.cpp LIBRARIES adv DATA throbber.gif hourglass.ani)
wx_add_sample(artprov arttest.cpp artbrows.cpp artbrows.h)
wx_add_sample(aui auidemo.cpp LIBRARIES adv aui html NAME auidemo)
wx_add_sample(calendar LIBRARIES adv)
wx_add_sample(caret)
wx_add_sample(clipboard)
wx_add_sample(collpane LIBRARIES adv)
wx_add_sample(combo LIBRARIES adv DATA dropbuth.png dropbutn.png dropbutp.png)
wx_add_sample(config conftest.cpp)
wx_add_sample(console CONSOLE IMPORTANT)
wx_add_sample(dataview IMPORTANT dataview.cpp mymodels.cpp mymodels.h LIBRARIES adv)
wx_add_sample(debugrpt LIBRARIES qa)
wx_add_sample(dialogs dialogs.cpp dialogs.h LIBRARIES adv DATA tips.txt)
wx_add_sample(dialup nettest.cpp)
wx_add_sample(display)
wx_add_sample(dnd dnd.cpp RES dnd.rc DATA wxwin.png)
wx_add_sample(docview docview.cpp doc.cpp view.cpp docview.h doc.h view.h
    RES docview.rc)
wx_add_sample(dragimag dragimag.cpp dragimag.h RES dragimag.rc
    DATA backgrnd.png shape01.png shape02.png shape03.png)
wx_add_sample(drawing DATA pat4.bmp pat35.bmp pat36.bmp image.bmp mask.bmp)
wx_add_sample(erase)
wx_add_sample(event)
wx_add_sample(except)
wx_add_sample(exec)
wx_add_sample(font)
wx_add_sample(fswatcher)
wx_add_sample(grid griddemo.cpp griddemo.h LIBRARIES adv)

wx_list_add_prefix(HELP_DOC_FILES doc/
    aindex.html ClassGraph.class ClassGraphPanel.class ClassLayout.class
    down.gif dxxgifs.tex HIER.html HIERjava.html icon1.gif icon2.gif
    index.html logo.gif NavigatorButton.class USE_HELP.html wx204.htm
    wx34.htm wxExtHelpController.html wxhelp.map wx.htm
    )
wx_add_sample(help demo.cpp doc.h LIBRARIES html adv
    DATA
    back.gif bullet.bmp contents.gif cshelp.txt doc.chm doc.cnt doc.hhc
    doc.hhk doc.hhp doc.hlp doc.hpj doc.zip forward.gif up.gif
    ${HELP_DOC_FILES}
    NAME helpdemo
    )
wx_add_sample(htlbox LIBRARIES html)
include(html.cmake)
wx_add_sample(image image.cpp canvas.cpp canvas.h RES image.rc
    DATA horse.png horse.jpg horse.bmp horse.gif horse.pcx horse.pnm
    horse_ag.pnm horse_rg.pnm horse.tif horse.tga horse.xpm horse.cur
    horse.ico horse3.ani smile.xbm toucan.png cmyk.jpg cursor.png)
foreach(lang ar bg cs de fr it ka pl ru sv ja ja_JP.EUC-JP)
    list(APPEND INTERNAT_DATA_FILES ${lang}/internat.po ${lang}/internat.mo)
endforeach()
wx_add_sample(internat DATA ${INTERNAT_DATA_FILES})
# IPC samples
set(wxSAMPLE_FOLDER ipc)
wx_add_sample(ipc client.cpp client.h connection.h ipcsetup.h NAME ipcclient LIBRARIES net)
wx_add_sample(ipc server.cpp server.h connection.h ipcsetup.h NAME ipcserver LIBRARIES net)
wx_add_sample(ipc CONSOLE baseclient.cpp connection.h ipcsetup.h NAME baseipcclient LIBRARIES net)
wx_add_sample(ipc CONSOLE baseserver.cpp connection.h ipcsetup.h NAME baseipcserver LIBRARIES net)
set(wxSAMPLE_FOLDER)
wx_add_sample(joytest joytest.cpp joytest.h DATA buttonpress.wav LIBRARIES adv)
wx_add_sample(keyboard)
wx_add_sample(layout layout.cpp layout.h)
wx_add_sample(listctrl listtest.cpp listtest.h RES listtest.rc)
wx_add_sample(mdi mdi.cpp mdi.h RES mdi.rc)
wx_add_sample(mediaplayer LIBRARIES media DEPENDS wxUSE_MEDIACTRL)
wx_add_sample(memcheck)
wx_add_sample(menu)
wx_add_sample(minimal IMPORTANT)
wx_add_sample(notebook notebook.cpp notebook.h LIBRARIES aui adv)
if(wxUSE_OPENGL)
    set(wxSAMPLE_SUBDIR opengl/)
    set(wxSAMPLE_FOLDER OpenGL)
    wx_add_sample(cube cube.cpp cube.h LIBRARIES gl)
    wx_add_sample(isosurf isosurf.cpp isosurf.h LIBRARIES gl DATA isosurf.dat.gz)
    wx_add_sample(penguin
        penguin.cpp dxfrenderer.cpp trackball.c
        dxfrenderer.h penguin.h trackball.h
        LIBRARIES gl
        DATA penguin.dxf.gz)
    wx_add_sample(pyramid
        pyramid.cpp oglstuff.cpp mathstuff.cpp oglpfuncs.cpp
        pyramid.h oglstuff.h mathstuff.h oglpfuncs.h
        LIBRARIES gl)
    set(wxSAMPLE_SUBDIR)
    set(wxSAMPLE_FOLDER)
endif()
wx_add_sample(ownerdrw RES ownerdrw.rc DATA sound.png nosound.png DEPENDS wxUSE_OWNER_DRAWN)
wx_add_sample(popup)
wx_add_sample(power)
wx_add_sample(preferences)
wx_add_sample(printing printing.cpp printing.h)
wx_add_sample(propgrid propgrid.cpp propgrid_minimal.cpp sampleprops.cpp
    tests.cpp sampleprops.h propgrid.h LIBRARIES adv propgrid NAME propgriddemo)
wx_add_sample(render FOLDER render)
wx_add_sample(render DLL renddll.cpp NAME renddll FOLDER render)
wx_add_sample(ribbon ribbondemo.cpp LIBRARIES ribbon adv NAME ribbondemo)
wx_add_sample(richtext LIBRARIES richtext adv html xml NAME richtextdemo)
wx_add_sample(sashtest sashtest.cpp sashtest.h LIBRARIES adv)
wx_add_sample(scroll)
wx_add_sample(secretstore CONSOLE DEPENDS wxUSE_SECRETSTORE)
wx_add_sample(shaped DATA star.png)
wx_add_sample(sockets client.cpp NAME client LIBRARIES net FOLDER sockets)
wx_add_sample(sockets server.cpp NAME server LIBRARIES net FOLDER sockets)
wx_add_sample(sockets CONSOLE baseclient.cpp NAME baseclient LIBRARIES net FOLDER sockets)
wx_add_sample(sockets CONSOLE baseserver.cpp NAME baseserver LIBRARIES net FOLDER sockets)
wx_add_sample(sound RES sound.rc DATA 9000g.wav cuckoo.wav doggrowl.wav tinkalink2.wav LIBRARIES adv)
wx_add_sample(splash DATA splash.png press.mpg LIBRARIES adv)
if(TARGET splash AND wxUSE_MEDIACTRL)
    target_link_libraries(splash media)
endif()
wx_add_sample(splitter)
wx_add_sample(statbar)
wx_add_sample(stc stctest.cpp edit.cpp prefs.cpp edit.h defsext.h prefs.h
    DATA stctest.cpp NAME stctest LIBRARIES stc)
wx_add_sample(svg svgtest.cpp)
wx_add_sample(taborder)
wx_add_sample(taskbar tbtest.cpp tbtest.h LIBRARIES adv DEPENDS wxUSE_TASKBARICON)
wx_add_sample(text)
wx_add_sample(thread)
wx_add_sample(toolbar RES toolbar.rc)
wx_add_sample(treectrl treetest.cpp treetest.h)
wx_add_sample(treelist LIBRARIES adv)
wx_add_sample(typetest typetest.cpp typetest.h)
wx_add_sample(uiaction)
wx_add_sample(validate)
wx_add_sample(vscroll vstest.cpp)
wx_add_sample(webview LIBRARIES webview stc adv NAME webviewsample)
# widgets Sample
set(SAMPLE_WIDGETS_SRC
    activityindicator.cpp
    bmpcombobox.cpp
    button.cpp
    checkbox.cpp
    choice.cpp
    clrpicker.cpp
    combobox.cpp
    datepick.cpp
    dirctrl.cpp
    dirpicker.cpp
    editlbox.cpp
    filectrl.cpp
    filepicker.cpp
    fontpicker.cpp
    gauge.cpp
    headerctrl.cpp
    hyperlnk.cpp
    itemcontainer.cpp
    listbox.cpp
    native.cpp
    notebook.cpp
    odcombobox.cpp
    radiobox.cpp
    searchctrl.cpp
    slider.cpp
    spinbtn.cpp
    static.cpp
    statbmp.cpp
    textctrl.cpp
    timepick.cpp
    toggle.cpp
    widgets.cpp
    widgets.h
    itemcontainer.h
    )
if(APPLE)
    # The source file using native controls uses Cocoa under OS X, so it must
    # be compiled as Objective C++ which means it must have .mm extension.
    # But this would make it uncompilable under the other platforms and we
    # don't want to have two files with identical contents. Hence this hack:
    # we have native.mm which just includes native.cpp under OS X, while
    # elsewhere we just compile native.cpp directly.
    list(APPEND SAMPLE_WIDGETS_SRC native_wrapper.mm)
endif()
wx_add_sample(widgets IMPORTANT ${SAMPLE_WIDGETS_SRC} LIBRARIES adv)
wx_add_sample(wizard LIBRARIES adv)
wx_add_sample(wrapsizer)

wx_list_add_prefix(XRC_RC_FILES rc/
    aui.xpm aui.xrc
    artprov.xpm artprov.xrc basicdlg.xpm
    basicdlg.xrc controls.xpm controls.xrc custclas.xpm custclas.xrc
    derivdlg.xpm derivdlg.xrc fileopen.gif filesave.gif frame.xrc
    fuzzy.gif menu.xrc platform.xpm platform.xrc quotes.gif
    resource.xrc toolbar.xrc uncenter.xpm
    objref.xrc objrefdlg.xpm
    uncenter.xrc update.gif
    variable.xpm variable.xrc
    variants.xpm variants.xrc
    throbber.gif stop.xpm
    wxbanner.gif
    )
wx_add_sample(xrc
    xrcdemo.cpp
    myframe.cpp
    derivdlg.cpp
    custclas.cpp
    objrefdlg.cpp
    derivdlg.h
    xrcdemo.h
    myframe.h
    custclas.h
    objrefdlg.h
    ${XRC_RC_FILES}
    LIBRARIES aui ribbon xrc html adv
    NAME xrcdemo
    )
wx_add_sample(xti xti.cpp classlist.cpp codereadercallback.cpp LIBRARIES xml
    DEPENDS wxUSE_EXTENDED_RTTI)

if(WIN32)
    # Windows only samples

    # DLL Sample
    wx_add_sample(dll DLL my_dll.cpp NAME my_dll FOLDER dll
        DEFINITIONS MY_DLL_BUILDING)
    if(NOT wxBUILD_SHARED)
        # this test only makes sense with statically built wx, otherwise
        # the same copy of wx would be used
        wx_add_sample(dll wx_exe.cpp NAME wx_exe FOLDER dll LIBRARIES my_dll)
    endif()

    wx_add_sample(dll sdk_exe.cpp NAME sdk_exe FOLDER dll LIBRARIES my_dll)
    wx_add_sample(flash)
    #TODO: renable when sample is fixed
    #wx_add_sample(mfc mfctest.cpp mfctest.h resource.h stdafx.h RES mfctest.rc)
    wx_add_sample(nativdlg nativdlg.cpp nativdlg.h resource.h RES nativdlg.rc)
    wx_add_sample(oleauto)
    wx_add_sample(regtest RES regtest.rc)
    wx_add_sample(taskbarbutton LIBRARIES adv DEPENDS wxUSE_TASKBARBUTTON)
endif()

=== debianbuild/reduce/debian/control ===
Source: reduce
Section: math
Priority: optional
Maintainer: REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>
Build-Depends: autoconf, libffi-dev, libx11-dev, libxext-dev, libxft-dev, texlive-latex-base, texlive-fonts-extra, texlive-latex-recommended, texlive-fonts-recommended, tex4ht, debhelper (>= 7.0.50~)
Standards-Version: 3.9.1
Homepage: http://reduce-algebra.sf.net/

Package: reduce-complete
Architecture: i386 amd64
Depends: gnuplot-x11 | gnuplot-qt, ${shlibs:Depends}, ${misc:Depends}
Conflicts: reduce-common, reduce-csl, reduce-psl, reduce-addons
Description: REDUCE Computer Algebra System -- common files
 REDUCE is a system for doing scalar, vector and matrix algebra by computer,
 which also supports arbitrary precision numerical approximation and
 interfaces to gnuplot to provide graphics. It can be used interactively
 for simple calculations (as illustrated in the screenshot above) but also
 provides a full programming language, with a syntax similar to other
 modern programming languages.
 .
 This package contains the complete set of files for CSL and PSL Reduce.

Package: reduce-common
Architecture: all
Depends: gnuplot-x11 | gnuplot-qt, ${misc:Depends}
Description: REDUCE Computer Algebra System -- common files
 REDUCE is a system for doing scalar, vector and matrix algebra by computer,
 which also supports arbitrary precision numerical approximation and
 interfaces to gnuplot to provide graphics. It can be used interactively
 for simple calculations (as illustrated in the screenshot above) but also
 provides a full programming language, with a syntax similar to other
 modern programming languages.
 .
 This package contains the files that are independent of the Lisp system used.

Package: reduce-csl
Architecture: any
Depends: reduce-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: REDUCE Computer Algebra System -- CSL version
 REDUCE is a system for doing scalar, vector and matrix algebra by computer,
 which also supports arbitrary precision numerical approximation and
 interfaces to gnuplot to provide graphics. It can be used interactively
 for simple calculations (as illustrated in the screenshot above) but also
 provides a full programming language, with a syntax similar to other
 modern programming languages.
 .
 This package contains the files for the CSL (Codemist Standard Lisp)
 version of REDUCE.


Package: reduce-psl
Architecture: i386 amd64 kfreebsd-amd64 kfreebsd-i386 mips powerpc sparc alpha hppa
Depends: reduce-common (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: REDUCE Computer Algebra System -- PSL version
 REDUCE is a system for doing scalar, vector and matrix algebra by computer,
 which also supports arbitrary precision numerical approximation and
 interfaces to gnuplot to provide graphics. It can be used interactively
 for simple calculations (as illustrated in the screenshot above) but also
 provides a full programming language, with a syntax similar to other
 modern programming languages.
 .
 This package contains the files for the PSL (Portable Standard Lisp)
 version of REDUCE.

Package: reduce-addons
Architecture: any
Depends: reduce-csl (= ${source:Version}) | reduce-psl (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Useful addons for the REDUCE Computer Algebra System
 These include:
   reduce-mode, an emacs mode
   redfront, a frontend with line editing and color output
   breduce, a REDUCE batch processing utility

=== debianbuild/reduce/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

ifdef BUILDTOPDIR
TOPDIR=$(BUILDTOPDIR)
else
TOPDIR=../..
endif

SYSTEMNAME=$(shell $(TOPDIR)/config.guess)

OSVER=$(shell $(TOPDIR)/scripts/findos.sh)
PSLVER=$(shell $(TOPDIR)/scripts/pslver.sh)
KNOWNPSLVER=AMD64 AMD64_ext amd64 linux

BUILDPSL=$(filter $(PSLVER),$(KNOWNPSLVER))

BUILDDIR=$(shell $(TOPDIR)/scripts/findhost.sh $(SYSTEMNAME))

CSLBUILDDIR=$(TOPDIR)/cslbuild/$(BUILDDIR)
PSLBUILDDIR=$(TOPDIR)/pslbuild/$(BUILDDIR)

DOCSRCDIR=$(TOPDIR)/doc/manual
DOCMISCDIR=$(TOPDIR)/doc/misc

DOCBASENAME=manual
EXTRADOCIMAGEBASENAMES=bild cmsy10 gnuplotex turtleeg

GENERICTOPDIR=$(TOPDIR)/generic

REDFRONTSRCDIR=$(GENERICTOPDIR)/newfront
REDFRONTBUILDDIR=$(GENERICTOPDIR)/newfront/build
LIBEDITSRCDIR=$(TOPDIR)/libraries/libedit-20140620-3.1
LIBEDITBUILDDIR=$(GENERICTOPDIR)/newfront/libedit

INSTALLDIR:=debian/tmp
SHAREDIR=$(INSTALLDIR)/usr/share/reduce
REDFRONTSHAREDIR=$(INSTALLDIR)/usr/share/reduce-addons/redfront
LIBDIR=$(INSTALLDIR)/usr/lib/reduce
TTFONTDIR=$(INSTALLDIR)/usr/share/fonts/truetype/reduce
TYPE1FONTDIR=$(INSTALLDIR)/usr/share/fonts/X11/Type1
FONTDIR=$(INSTALLDIR)/usr/share/reduce/fonts
DOCDIR=$(INSTALLDIR)/usr/share/doc/reduce
ADDONDOCDIR=$(INSTALLDIR)/usr/share/doc/reduce-addons
BINDIR=$(INSTALLDIR)/usr/bin
MANDIR=$(INSTALLDIR)/usr/share/man
EMACSSITELISPDIR=$(INSTALLDIR)/usr/share/emacs/site-lisp/reduce
EMACSSITESTARTDIR=$(INSTALLDIR)/etc/emacs/site-start.d

RSYNC_CMD=rsync -a --cvs-exclude --delete --delete-excluded


%:
	dh $@ 

distclean:
	dh_distclean
	-make -C $(DOCMISCDIR) clean
	-make -C $(DOCSRCDIR) clean
	-test -d $(CSLBUILDDIR) && make -C $(CSLBUILDDIR) distclean
ifneq ($(BUILDPSL),)
	-test -d $(PSLBUILDDIR) && make -C $(PSLBUILDDIR) distclean
endif
	rm -rf $(GENERICTOPDIR)/newfront/build
	rm -rf $(GENERICTOPDIR)/newfront/libedit
	rm -rf $(GENERICTOPDIR)/newfront/lib
	rm -rf $(GENERICTOPDIR)/newfront/include

clean: 
	dh_clean
#	cd $(TOPDIR) ; make clean
	-make -C $(DOCMISCDIR) clean
	-make -C $(DOCSRCDIR) clean
	-test -d $(CSLBUILDDIR) && make -C $(CSLBUILDDIR) clean 
ifneq ($(BUILDPSL),)   
	-test -d $(PSLBUILDDIR) && make -C $(PSLBUILDDIR) clean
endif
	rm -rf $(GENERICTOPDIR)/newfront/build
	rm -rf $(GENERICTOPDIR)/newfront/libedit
	rm -rf $(GENERICTOPDIR)/newfront/lib
	rm -rf $(GENERICTOPDIR)/newfront/include

#override_dh_auto_configure:
configure: configure-stamp
configure-stamp:
	dh_testdir
	cd $(TOPDIR) ; ./configure --prefix=/usr --with-csl
ifneq ($(BUILDPSL),)
	cd $(TOPDIR) ; ./configure --with-psl
endif
	mkdir -p $(REDFRONTBUILDDIR)
	cd $(REDFRONTSRCDIR) ; autoreconf -f -i -v
	cd $(REDFRONTBUILDDIR) ; ../configure
	mkdir -p $(LIBEDITBUILDDIR)
	cd $(LIBEDITBUILDDIR) ; autoreconf -f -i -v; $(LIBEDITSRCDIR)/configure --prefix=$(REDFRONTSRCDIR)
	touch configure-stamp


build:	configure-stamp build-stamp
build-stamp:
	dh_testdir
#	cd $(TOPDIR) ; make
	cd $(CSLBUILDDIR) ; make bootstrapreduce.img ; make csl.img ; make
ifneq ($(BUILDPSL),)
	cd $(PSLBUILDDIR) ; make
endif
	cd $(DOCMISCDIR) ; make
	cd $(DOCSRCDIR) ; make
	cd $(LIBEDITBUILDDIR) ; make install
	cd $(REDFRONTBUILDDIR) ; make
	touch build-stamp


install: install-stamp
install-stamp: build-stamp
# create target directories
	mkdir -p $(SHAREDIR)/scripts $(LIBDIR)/pslbuild/psl $(LIBDIR)/pslbuild/red $(LIBDIR)/cslbuild/csl $(SHAREDIR)/packages $(BINDIR) $(DOCDIR) $(MANDIR)/man1
	mkdir -p $(REDFRONTSHAREDIR)/redfront $(EMACSSITELISPDIR) $(EMACSSITESTARTDIR) $(ADDONDOCDIR)
# copy documentation files
	cp $(TOPDIR)/doc/misc/primer.tex $(TOPDIR)/doc/misc/primer.pdf $(TOPDIR)/doc/misc/sl.tex $(TOPDIR)/doc/misc/sl.bib $(TOPDIR)/doc/misc/sl.pdf \
           $(TOPDIR)/csl/reduce.doc/BINARY-LICENSE.txt $(TOPDIR)/csl/reduce.doc/BSD-LICENSE.txt $(TOPDIR)/csl/reduce.doc/LGPL-2.1.txt $(TOPDIR)/doc/manual/redlogo.png $(DOCDIR)
	cp $(DOCSRCDIR)/*.tex $(DOCDIR)
	cp $(DOCSRCDIR)/$(DOCBASENAME).pdf $(DOCSRCDIR)/$(DOCBASENAME)*.html $(DOCSRCDIR)/$(DOCBASENAME)*.png $(DOCSRCDIR)/$(DOCBASENAME).css $(DOCDIR)
	for n in $(EXTRADOCIMAGEBASENAMES); do cp $(DOCSRCDIR)/${n}*.png $(DOCDIR) ; done
	cp $(DOCDIR)/$(DOCBASENAME).html $(DOCDIR)/index.html
	chmod -x $(DOCDIR)/*
	cp $(GENERICTOPDIR)/breduce/breduce.tex $(GENERICTOPDIR)/breduce/breduce.bbl $(GENERICTOPDIR)/breduce/breduce.pdf $(ADDONDOCDIR)
# copy man files
	cp debian/redcsl.1 debian/redpsl.1 $(MANDIR)/man1
	cp $(REDFRONTSRCDIR)/redfront.1 $(MANDIR)/man1
	ln -s redfront.1 $(MANDIR)/man1/rfcsl.1
	ln -s redfront.1 $(MANDIR)/man1/rfpsl.1
	cp $(GENERICTOPDIR)/breduce/breduce.1 $(MANDIR)/man1
# copy CSL files
	cp -r $(CSLBUILDDIR)/csl/reduce.img \
		$(CSLBUILDDIR)/csl/reduce \
		$(CSLBUILDDIR)/csl/reduce.resources \
		$(CSLBUILDDIR)/csl/bootstrapreduce.img \
		$(CSLBUILDDIR)/csl/bootstrapreduce \
		$(CSLBUILDDIR)/csl/csl.img \
		$(CSLBUILDDIR)/csl/csl \
			$(LIBDIR)/cslbuild/csl
#	$(RSYNC_CMD) --no-perms $(CSLBUILDDIR)/csl/reduce.doc/ $(DOCDIR)/
	mkdir -p $(FONTDIR)
	$(RSYNC_CMD) --chmod=Fa-x --exclude "/src/***" $(CSLBUILDDIR)/csl/reduce.fonts/ $(FONTDIR)
#	chmod -x $(FONTDIR)/*.ttf $(FONTDIR)/*.pfa $(FONTDIR)/*.pfb
ifneq ($(BUILDPSL),)                                                          # copy PSL files
	$(RSYNC_CMD) --exclude "kernel/***" --exclude "xport.*" $(PSLBUILDDIR)/psl/ $(LIBDIR)/pslbuild/psl/
	chmod -x $(LIBDIR)/pslbuild/psl/*.b
	$(RSYNC_CMD) $(PSLBUILDDIR)/red/ $(LIBDIR)/pslbuild/red/
	chmod -x $(LIBDIR)/pslbuild/red/*
	$(TOPDIR)/psl/saveimage.sh $(PSLBUILDDIR) $(abspath $(LIBDIR)/pslbuild/red) /usr/lib/reduce/pslbuild
endif
# copy common files
	$(RSYNC_CMD) --no-perms --chmod=Fa-x --exclude "/regressions/***" $(TOPDIR)/packages/ $(SHAREDIR)/packages/
	chmod a+x $(TOPDIR)/packages/gcref/gcref $(TOPDIR)/packages/redlog/regressions/make.sh
	ln -f -s ../../../../share/reduce/fonts $(LIBDIR)/cslbuild/csl/reduce.fonts
	ln -f -s ../../../../share/doc/reduce $(LIBDIR)/cslbuild/csl/reduce.doc
	ln -f -s ../../lib/reduce/pslbuild $(SHAREDIR)/pslbuild
	ln -f -s ../../lib/reduce/cslbuild $(SHAREDIR)/cslbuild
# copy font files for CSL
	mkdir -p $(TTFONTDIR) $(TYPE1FONTDIR)
	cp $(CSLBUILDDIR)/csl/reduce.fonts/*.ttf $(TTFONTDIR)
	cp $(CSLBUILDDIR)/csl/reduce.fonts/*.pfb $(TYPE1FONTDIR)
	chmod -x $(TTFONTDIR)/* $(TYPE1FONTDIR)/*
# copy shell scripts for running REDUCE
	cp -a debian/runpsl.sh $(BINDIR)/redpsl
	cp -a debian/runcsl.sh $(BINDIR)/redcsl
	cp -a debian/runbootstrapreduce.sh $(BINDIR)/bootstrapreduce
	cp -a debian/runcsllisp.sh $(BINDIR)/csl
# copy rest
	cp $(REDFRONTBUILDDIR)/rfcsl $(BINDIR)
	cp $(REDFRONTBUILDDIR)/rfpsl $(BINDIR)
	cp $(GENERICTOPDIR)/breduce/breduce $(BINDIR)
	cp $(GENERICTOPDIR)/emacs/reduce-mode.el $(EMACSSITELISPDIR)
	cp debian/50reduce-emacs.el $(EMACSSITESTARTDIR)
	chmod a-x $(EMACSSITELISPDIR)/reduce-mode.el $(EMACSSITESTARTDIR)/50reduce-emacs.el

# run dh_install to copy the files into the package build dirs
	dh_install

	touch install-stamp


# Build architecture-independent files here.
binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installexamples -i
	dh_installmenu -i
	dh_installemacsen -i
	dh_installcron -i
	dh_installman -i
#	dh_desktop -i
	dh_installinfo -i
	dh_installchangelogs  -i
	dh_lintian -i
	dh_link -i
	dh_strip -i
	dh_compress -i 
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installexamples -a
	dh_installmenu -a
	dh_installemacsen -a
	dh_installcron -a
	dh_installman -a
#	dh_desktop -a
	dh_installinfo -a
	dh_installchangelogs  -a
	dh_lintian -a
	dh_link -a
